function initialize() {

    getMacAddress((macAddress) => {
        if(macAddress) {
            var provisioningToken = Utility.encodeGUID(macAddress);
            console.log('Encoded MAC address:', provisioningToken);
        }

        if(provisioningToken) {
            var pwaURL = 'https://www.korbyt.com/pwa?pt=' + provisioningToken;
        }
        else{
            var pwaURL = 'https://www.korbyt.com/pwa';
        }    
        
        var iframe = document.createElement('iframe');
        iframe.src = pwaURL;
        iframe.style.position = 'fixed';
        iframe.style.top = '0';
        iframe.style.left = '0';
        iframe.style.width = '100%';
        iframe.style.height = '100%';
        iframe.style.border = 'none';
        document.body.appendChild(iframe);    
    });

}

function getMacAddress(callback) {
    if (typeof webOS === 'undefined') {
        console.error('webOS.js library not loaded. Please ensure you have included the library in your project.');
        return;
    }

    const service = 'luna://com.webos.service.sm';

    const handleResponse = (response) => {
        if (response.returnValue && response.idList) {
            callback(response.idList[0].idValue);
        } else {
            console.error('Failed to get MAC address:', response);
            callback(null);
        }
    };

    const handleError = (error) => {
        console.error('Failed to get MAC address:', error);
        callback(null);
    };

    const parameters = {"idType": ['LGUDID']};

    webOS.service.request(service, {
        method: 'deviceid/getIDs',
        parameters: parameters,
        onSuccess: handleResponse,
        onFailure: handleError
    });
}


function encodeMac(input)  {
    var clean = input.toUpperCase().replace(/[^0-9A-Z]/gi, '');
    var n = parseInt(clean, 16);
    return Utility.encode(n) + '-' + Utility.genCheckDigits(n);
}